<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  CTA as CallToAction,
  Table as SlpTable,
  CopyMedia,
  Copy,
  CopyResources,
  SlpBreadcrumb,
  FeaturedMedia,
  NextStep,
} from '../../../components/common/index.vue';
import {
  CopyMediaCard,
  CompanyCopyCard as CopyCard,
} from '../../../components/company/index.vue';
import {
  TopicsCards,
  BenefitsIcons,
  TopicsHeader,
  TopicsCta,
  TopicsCopyBlock,
  TopicsEmphasis,
  TopicsInfoTable,
} from '../../../components/topics/index.vue';
import { PartnersCopyBlock } from '../../../components/partners/index.vue';
import {
  handleTopicFromContentful,
  fetchTopicBySlug,
} from '~/services/topics-contentful.js';

import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    CallToAction,
    Copy,
    CopyResources,
    CopyCard,
    CopyMediaCard,
    CopyMedia,
    TopicsCards,
    TopicsCta,
    BenefitsIcons,
    TopicsHeader,
    FeaturedMedia,
    SlpTable,
    SlpBreadcrumb,
    TopicsCopyBlock,
    SolutionsResourceCards,
    TopicsInfoTable,
    TopicsEmphasis,
    NextStep,
    PartnersCopyBlock,
  },
  nuxtI18n: false,
  async asyncData({ params, error }: any) {
    try {
      let contentfulData;
      if (!params.slug) {
        contentfulData = await fetchTopicBySlug('version-control');
      } else {
        contentfulData = await fetchTopicBySlug(
          `version-control/${params.slug}`,
        );
      }

      if (!contentfulData) {
        error({ statusCode: 404 });
      }
      const topics = handleTopicFromContentful(contentfulData);

      return { topics };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  data() {
    return {
      sections: [],
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).topics, this.$route.path);
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <div v-if="topics.side_menu">
        <SlpBreadcrumb class="slp-mt-32" :crumbs="topics.crumbs" />
        <TopicsHeader
          v-if="topics.topics_header"
          :data="topics.topics_header.data"
        />
        <SlpSideNavigation
          :data="topics.side_menu"
          :class="{
            'side-navigation--w-hero': topics.topics_header,
            'side-navigation--w-old-hero': topics.old_topics_header,
          }"
        >
          <template v-if="topics.side_menu.hyperlinks" #footer>
            <div>
              <SlpTypography
                v-show="topics.side_menu.hyperlinks.text"
                tag="div"
                variant="body3-bold"
                class="nav-heading"
                >{{ topics.side_menu.hyperlinks.text }}</SlpTypography
              >
              <SlpButton
                v-for="(button, buttonIndex) in topics.side_menu.hyperlinks
                  .data"
                :key="buttonIndex"
                class="hyperlinks"
                :variant="button.variant"
                :href="button.href"
                :data-ga-name="button.data_ga_name"
                :data-ga-location="button.data_ga_location"
                >{{ button.text }}
                <SlpIcon
                  v-if="button.icon"
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </div>
          </template>
          <component
            :is="component.name"
            v-for="(component, index) in topics.side_menu.content"
            :key="component.name + `-${index}`"
            :data="component.data"
          />
        </SlpSideNavigation>
      </div>
      <component
        :is="component.name"
        v-for="(component, index) in topics.components"
        :key="component.name + `-${index}`"
        :data="component.data"
      />
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
</template>
<style lang="scss" scoped>
:deep .dropdown {
  margin: $spacing-32 0;
}
:deep #collapsible-sidebar {
  overflow-y: scroll;
  max-height: calc(100vh - $spacing-96);
  height: 100%;
}
:deep #collapsible-sidebar-content {
  margin-top: $spacing-96;
}
.side-navigation--w-old-hero {
  :deep #collapsible-sidebar {
    padding-top: 0 !important;
  }
}
.side-navigation--w-hero {
  :deep #collapsible-sidebar {
    margin-top: $spacing-96;
  }
}
.hyperlinks {
  font-size: $font-size-default;
  line-height: 20px;
  font-weight: $font-weight-normal;
  text-align: left !important;
}
.nav-heading {
  margin-bottom: $spacing-8;
}
:deep .copy {
  text-align: start !important;
}

/* Override component styles*/
.no_decoration :deep .decoration {
  display: none;
}

.no_header :deep .anchor-header {
  display: none;
}
.enable_blockquote :deep blockquote {
  background-color: $color-surface-800;
  padding: $spacing-48;
  border-radius: 24px;
  margin: $spacing-32 0;
}
</style>
